local DeathReport = Apollo.GetAddon("DeathReport")

function DeathReport:OnGroupJoin() --When *I* join a group.
	--Print("OnGroupJoin")
	self:UpdateChannel()
	self:StartJoinRequest()
end

function DeathReport:OnGroupAdd(strPlayerName) --When another player joins a group.
	--Print("OnGroupAdd("..strPlayerName..")")
end

function DeathReport:OnGroupLeft(eReason) --When *I* leave a group.
	for key,val in pairs(GroupLib.RemoveReason) do
		if eReason == val then
			Print("OnGroupLeft("..key..")")
		end
	end
	self:UpdateChannel()
end

function DeathReport:OnGroupRemove(strPlayerName, eReason) -- When another player leaves a group
	--[[for key,val in pairs(GroupLib.RemoveReason) do
		if eReason == val then
			Print("OnGroupRemove("..key..")")
		end
	end]]--
	self:UpdateChannel()
end

function DeathReport:OnGroupMemberPromotion(strPlayerName, bSelf)
	self:UpdateChannel()
end

--[[function DeathReport:OnGroupPromotion(strName, bSelf)
	
	Print("OnGroupPromotion:"..strName..","..tostring(bSelf))
end

function DeathReport:OnGroupChange()
	--self:UpdateCohorts()
end]]--

function DeathReport:GetPartyLeader()
	for idx=1, GroupLib.GetMemberCount() do
		local tMember = GroupLib.GetGroupMember(idx)
		if tMember.bIsLeader then
			return tMember.strCharacterName
		end
	end
	return nil
end

function DeathReport:UpdateChannel() --TODO: Remove GPU because can return nil when not OCC
	--Print("Updating channel...")
	local strLeader = self:GetPartyLeader() or GameLib.GetPlayerUnit():GetName()
	if strLeader then
		self:JoinChannel("Death"..strLeader)
	else
		self.channel = nil
	end
end

function DeathReport:StartJoinRequest()
	self.timerJoin = ApolloTimer.Create(2, false, "SendJoinRequest", self)
end


function DeathReport:SendJoinRequest() --Z
	self.timerJoin = nil

	local tMsg = {}
	tMsg.type = "JoinRequest"

	self:SendMessage(tMsg)
end
function DeathReport:OnJoinRequest(tMsg, strSender) --A,B,C,D
	--Print("OnJoinRequest:"..strSender)
	local bInGroup = false
	for idx,strPlayerName in pairs(self.tGroup) do
		if strPlayer == strSender then
			table.remove(self.tGroup, idx)
		end
	end
	table.insert(self.tGroup, strSender)
	self:UpdateGroupReporter()
	self:SendJoinResponse(strSender)
end

function DeathReport:SendJoinResponse(strRecipient) --A,B,C,D
	local tMsg = {}
	tMsg.type = "JoinResponse"
	
	self:SendMessage(tMsg)
end
function DeathReport:OnJoinResponse(tMsg, strSender) --Z
	table.insert(self.tGroup, strSender)
	self:UpdateGroupReporter()
end

function DeathReport:UpdateGroupReporter()
	table.sort(self.tGroup)
	self.bReporter = self.tGroup[1] == GameLib.GetPlayerUnit():GetName()
	--Print("Am I Reporter? " .. tostring(self.bReporter))
end

function DeathReport:JoinChannel(strChannelName)
	if strChannelName then
		self.channel = ICCommLib.JoinChannel(strChannelName, "HandleMessage", self)
	else
		self.channel = nil
	end
end

function DeathReport:SendMessage(tMsg)
	local strRecipient = tMsg.recipient == nil and "Global" or tMsg.recipient

	--Print("Comm send: "..GameLib.GetPlayerUnit():GetName().."@"..self.strChannelName..": "..tMsg.type.."->"..strRecipient)
	self.channel:SendMessage(tMsg)
end

function DeathReport:HandleMessage(channel, tMsg, strSender)
	local strRecipient = tMsg.recipient == nil and "Global" or tMsg.recipient
	
	--Print("Comm receive: "..strSender.."@"..self.strChannelName..": "..tMsg.type.."->"..strRecipient)
	
	if self["On"..tMsg.type] ~= nil then
		if tMsg.recipient == nil or tMsg.recipient == GameLib.GetPlayerUnit():GetName() then
			self["On"..tMsg.type](self, tMsg, strSender)
		end
	end
end